﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 판매 데이터
    /// </summary>
    public class SalesData
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 고유 ID
        /// </summary>
        private static int UniqueID = 37;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public int ID { get; set; }

        #endregion
        #region 지역 ID - RegionID

        /// <summary>
        /// 지역 ID
        /// </summary>
        public int RegionID { get; set; }

        #endregion
        #region 영역 - Region

        /// <summary>
        /// 영역
        /// </summary>
        public string Region { get; set; }

        #endregion
        #region 판매일 - SalesDate

        /// <summary>
        /// 판매일
        /// </summary>
        public DateTime SalesDate { get; set; }

        #endregion
        #region 판매액 - Sales

        /// <summary>
        /// 판매액
        /// </summary>
        public decimal Sales { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SalesData()

        /// <summary>
        /// 생성자
        /// </summary>
        public SalesData()
        {
            ID = UniqueID++;
        }

        #endregion
        #region 생성자 - SalesData(id, regionID, region, salesDate, sales)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="id">ID</param>
        /// <param name="regionID">지역 ID</param>
        /// <param name="region">지역</param>
        /// <param name="salesDate">판매일</param>
        /// <param name="sales">판매액</param>
        public SalesData(int id, int regionID, string region, DateTime salesDate, decimal sales)
        {
            ID             = id;
            RegionID       = regionID;
            SalesDate      = salesDate;
            Region         = region;
            Sales          = sales;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 판매 데이터 리스트 구하기 - GetSalesDataList()

        /// <summary>
        /// 판매 데이터 리스트 구하기
        /// </summary>
        /// <returns>판매 데이터 리스트</returns>
        public static List<SalesData> GetSalesDataList()
        {
            List<SalesData> list = new List<SalesData>();

            list.Add(new SalesData(0 , -1, "Western Europe", new DateTime(2020, 1, 1), 33000));
            list.Add(new SalesData(1 ,  0, "Austria"       , new DateTime(2019, 2, 1), 28000));
            list.Add(new SalesData(2 ,  0, "France"        , new DateTime(2018, 3, 1), 27000));
            list.Add(new SalesData(3 ,  0, "Germany"       , new DateTime(2020, 1, 1), 33000));
            list.Add(new SalesData(4 ,  0, "Spain"         , new DateTime(2019, 2, 1), 10300));
            list.Add(new SalesData(5 ,  0, "Switzerland"   , new DateTime(2018, 3, 1), 10730));
            list.Add(new SalesData(6 ,  0, "United Kingdom", new DateTime(2020, 1, 1), 13967));

            list.Add(new SalesData(17, -1, "Eastern Europe", new DateTime(2019, 2, 1), 24580));
            list.Add(new SalesData(18, 17, "Belarus"       , new DateTime(2018, 3, 1), 18800));
            list.Add(new SalesData(19, 17, "Bulgaria"      , new DateTime(2020, 1, 1), 2821 ));
            list.Add(new SalesData(20, 17, "Croatia"       , new DateTime(2019, 2, 1), 3890 ));
            list.Add(new SalesData(21, 17, "Russia"        , new DateTime(2018, 1, 1), 24580));

            list.Add(new SalesData(26, -1, "North America" , new DateTime(2020, 3, 1), 32800));
            list.Add(new SalesData(27, 26, "USA"           , new DateTime(2019, 1, 1), 32800));
            list.Add(new SalesData(28, 26, "Canada"        , new DateTime(2018, 2, 1), 27000));

            list.Add(new SalesData(29, -1, "South America" , new DateTime(2020, 3, 1), 17590));
            list.Add(new SalesData(30, 29, "Argentina"     , new DateTime(2019, 1, 1), 17590));
            list.Add(new SalesData(31, 29, "Brazil"        , new DateTime(2018, 2, 1), 9480 ));

            list.Add(new SalesData(32, -1, "Asia"          , new DateTime(2020, 3, 1), 22547));
            list.Add(new SalesData(34, 32, "India"         , new DateTime(2019, 1, 1), 5320 ));
            list.Add(new SalesData(35, 32, "Japan"         , new DateTime(2018, 2, 1), 12859));
            list.Add(new SalesData(36, 32, "China"         , new DateTime(2020, 3, 1), 22547));

            return list;
        }

        #endregion
    }
}